﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
namespace Prohlizec
{
    public partial class Form1 : Form
    {
        private string CurrentDirecory_value;
        Images display;
        int selected_index;
        #region Konstriktory
        public Form1()
        {
            CurrentDirecory_value = AppDomain.CurrentDomain.BaseDirectory;
            InitializeComponent();
            display = new Images();
            dirListBox1.Path = CurrentDirecory_value;
            driveListBox1.Drive = CurrentDirecory_value.Substring(0, 3);
            LoadFileList();
        }
        public Form1(string directory,bool loadfile)
        {
            if (!loadfile)
            {
                CurrentDirecory_value = directory;
                InitializeComponent();
                display = new Images();
                dirListBox1.Path = CurrentDirecory_value;
                driveListBox1.Drive = CurrentDirecory_value.Substring(0, 3);
                LoadFileList();
                
            }
            else
            {
                int last_lomeno = directory.LastIndexOf("\\");
                string dir = directory.Substring(0, last_lomeno+1);
                string name = directory.Substring(last_lomeno +1);
                CurrentDirecory_value = dir;
                InitializeComponent();
                display = new Images();
                dirListBox1.Path = CurrentDirecory_value;
                driveListBox1.Drive = CurrentDirecory_value.Substring(0, 3);
                LoadFileList();
                display.soubory_info = listView1.Items;
                int i;
                int akt=-1;
                for (i = 0; i < listView1.Items.Count; i++)
                {
                    if (listView1.Items[i].Text == name)
                    {
                        akt = i;
                        break;
                    }
                }
                if (akt!=-1)
                {
                    display.aktualni = akt;
                    display.ShowDialog();
                }

            }
        }
        #endregion
        private void driveListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                dirListBox1.Path = driveListBox1.Drive;
            }
            catch (IOException ex) { MessageBox.Show("Nelze vybrat tuto jednotku:" + ex.ToString()); driveListBox1.Drive = dirListBox1.Path.Substring(0, 3); }
        }
        #region Nacteni ListViewu
        void LoadFileList()
        {
            XmlThumb thumbs;
            XmlSerializer xmls = new XmlSerializer(typeof(XmlThumb));
            StreamReader sr = new StreamReader(new FileStream(CurrentDirecory_value + "\\thumb.dat", FileMode.OpenOrCreate));
            try
            {
                thumbs = xmls.Deserialize(sr) as XmlThumb;
            }
            catch { thumbs = new XmlThumb(); thumbs.binary = new List<byte[]>(); thumbs.file = new List<string>(); }
            sr.Close();
            DirectoryInfo directionaryInfo = new DirectoryInfo(CurrentDirecory_value);
            listView1.Items.Clear();
            imageList1.Images.Clear();
            int i=0;
            Text = "Prohlížeč adresářů - prosím čekejte";
            FileInfo[] files = directionaryInfo.GetFiles();
            Array.Sort(files,new FileInfo_Comparrer());
            foreach (FileInfo file in files)
            {
                if (file.Extension.ToLower() == ".jpg" || file.Extension.ToLower() == ".jpeg")
                {
                    ListViewItem listViewItem = new ListViewItem();
                    listViewItem.Text = file.Name;
                    listViewItem.Tag = file;
                    listView1.Items.Add(listViewItem);
                    i++;
                    if (i > 20)
                    {
                        Application.DoEvents();
                        i = 0;
                    }
                }
            }
            Application.DoEvents();
            i = 0;
            foreach (ListViewItem lvi in listView1.Items )
            {
                string fn = (lvi.Tag as FileInfo).FullName;
                if (thumbs.file.Contains((lvi.Tag as FileInfo).Name))
                {
                    int index = thumbs.file.IndexOf((lvi.Tag as FileInfo).Name);
                    imageList1.Images.Add(new Bitmap(new MemoryStream(thumbs.binary[index])));
                    lvi.ImageIndex = i;
                    i++;
                }
                else
                {
                    imageList1.Images.Add(new Bitmap(fn));
                    lvi.ImageIndex = i;
                    thumbs.file.Add((lvi.Tag as FileInfo).Name);
                    MemoryStream ms = new MemoryStream();
                    imageList1.Images[i].Save(ms, System.Drawing.Imaging.ImageFormat.Jpeg);
                    thumbs.binary.Add(ms.ToArray());
                    ms.Close();
                    ms.Flush();
                    i++;
                    Application.DoEvents();
                }
            }
            try
            {
                StreamWriter sw = new StreamWriter(CurrentDirecory_value + "\\thumb.dat");
                File.SetAttributes(CurrentDirecory_value + "\\thumb.dat", FileAttributes.System | FileAttributes.Hidden);
                xmls.Serialize(sw, thumbs);
                sw.Close();
            }
            catch { }
            Text = "Prohlížeč adresářů";
        }
        #endregion
        private void dirListBox1_Change(object sender, EventArgs e)
        {
            CurrentDirecory_value = dirListBox1.Path;
            LoadFileList();
        }
        private void listView1_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {
            label1.Text = e.Item.Text;
            label2.Text = (e.Item.Tag as FileInfo).FullName;
            label3.Text = ((e.Item.Tag as FileInfo).Length/1024).ToString()+"kB";
            label4.Text = (e.Item.Tag as FileInfo).LastWriteTime.ToString();
            label5.Text =  new Bitmap((e.Item.Tag as FileInfo).FullName).Size.ToString();
            selected_index = e.ItemIndex;
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            display.soubory_info = listView1.Items;
            display.aktualni = selected_index;
            display.ShowDialog();
        }
        private void listView1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar ==char.Parse("\r"))
                listView1_DoubleClick(null, null);
        }

        private void Form1_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            listView1.Focus();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyData)
            {
                case Keys.Escape:
                    Close();
                    break;
            }
        }
    }
    #region Dalsi tridy
    public class FileInfo_Comparrer : IComparer<FileInfo>
    {
        public int Compare(FileInfo x, FileInfo y)
        {
            return string.Compare(x.Name, y.Name);
        }
    }
    [Serializable()]
    public class XmlThumb
    {
        [XmlElement("Filename")]
        public List<string> file;
        [XmlElement("BinaryData")]
        public List<byte[]> binary;
    }
    #endregion
}
