﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
namespace Prohlizec
{
    public partial class Images : Form
    {
        public ListView.ListViewItemCollection soubory_info;
        public int aktualni;
        public double zoom=1;
        public Images()
        {
            InitializeComponent();
        }

        private void Images_Load(object sender, EventArgs e)
        {
            pictureBox1.Image= new Bitmap((soubory_info[aktualni].Tag as FileInfo).FullName);
            pictureBox1.Size = pictureBox1.Image.Size;
            Text = "Image - " + soubory_info[aktualni].Text;
        }
        #region Eventy Na tlacitkach
        private void button1_Click(object sender, EventArgs e)
        {
            aktualni = 0;
            Images_Load(null, null);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            aktualni = soubory_info.Count - 1;
            Images_Load(null, null);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            aktualni++;
            if (aktualni >= soubory_info.Count)
                aktualni = 0;
            Images_Load(null, null);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            aktualni--;
            if (aktualni < 0)
                aktualni = soubory_info.Count - 1;
            Images_Load(null, null);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            zoom -= 0.02;
            pictureBox1.Width =(int)(pictureBox1.Image.Width*zoom);
            pictureBox1.Height = (int)(pictureBox1.Image.Height * zoom);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            zoom += 0.02;
            pictureBox1.Width = (int)(pictureBox1.Image.Width * zoom);
            pictureBox1.Height = (int)(pictureBox1.Image.Height * zoom);
        }
        private void button1_KeyDown(object sender, KeyEventArgs e)
        {
            Images_KeyDown(null, e);
        }
        private void button8_Click(object sender, EventArgs e)
        {
            pictureBox1.Size = pictureBox1.Image.Size;
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int window_height = Height;
            int image_height = pictureBox1.Image.Height;
            double scale = (double)image_height / (double)window_height;
            double new_width = pictureBox1.Image.Width / scale;
            double new_height = Height;
            if (new_width > Width)
            {
                double wscale = (double)pictureBox1.Image.Width / (double)Width;
                new_height = pictureBox1.Image.Height / wscale;
                new_width = Width;
            }
            pictureBox1.Height = (int)new_height;
            pictureBox1.Width = (int)new_width;
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled)
                timer1.Enabled = false;
            else
                timer1.Enabled = true;
        }

#endregion
        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            button5_Click(null, null);
        }

        #region Key eventy
        private void Images_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyData)
            {
                case Keys.Escape:
                    button5_Click(null, null);
                    break;
                case Keys.PageDown:
                    button3_Click(null, null);
                    break;
                case Keys.PageUp:
                    button2_Click(null, null);
                    break;
                case Keys.Home:
                    button1_Click(null, null);
                    break;
                case Keys.End:
                    button4_Click(null, null);
                    break;
                case Keys.Add:
                    button7_Click(null, null);
                    break;
                case Keys.Subtract:
                    button6_Click(null, null);
                    break;
                case Keys.S:
                    button10_Click(null, null);
                    break;
                case Keys.Divide:
                    button9_Click(null, null);
                    break;
                case Keys.Multiply:
                    button8_Click(null, null);
                    break;

            }
        }

#endregion
        private void timer1_Tick(object sender, EventArgs e)
        {
            button3_Click(null, null);
            button9_Click(null, null);
        }

    }
}
